! SEGA 32X support code for SH2
! by Chilly Willy
! Rom header and SH2 init/exception code - must be first in object list

        .text

! Standard MD Header at 0x000

        .incbin "src/m68k_crt0.bin"

! Standard Mars Header at 0x3C0

        .ascii	"Wolf3D for 32X  "		        /* module name */
	    .long   0x00000000			            /* version */
        .long   _etext-0x02000000               /* Source (in ROM) */
        .long   0x00000000                      /* Destination (in SDRAM) */
        .long   _sdata                          /* Size */
        .long   0x06000240                      /* Master SH2 Jump */
        .long   0x06000244                      /* Slave SH2 Jump */
        .long   0x06000000                      /* Master SH2 VBR */
        .long   0x06000120                      /* Slave SH2 VBR */

! Standard MD startup code at 0x3F0

        .incbin "src/m68k_crt1.bin"


        .data

! Master Vector Base Table at 0x06000000

        .long   mstart      /* Cold Start PC */
        .long   0x06040000  /* Cold Start SP */
        .long   mstart      /* Manual Reset PC */
        .long   0x06040000  /* Manual Reset SP */
        .long   main_err    /* Illegal instruction */
        .long   0x00000000  /* reserved */
        .long   main_err    /* Invalid slot instruction */
        .long   0x20100400  /* reserved */
        .long   0x20100420  /* reserved */
        .long   main_err    /* CPU address error */
        .long   main_err    /* DMA address error */
        .long   main_err    /* NMI vector */
        .long   main_err    /* User break vector */
        .space  76          /* reserved */
        .long   main_err    /* TRAPA #32 */
        .long   main_err    /* TRAPA #33 */
        .long   main_err    /* TRAPA #34 */
        .long   main_err    /* TRAPA #35 */
        .long   main_err    /* TRAPA #36 */
        .long   main_err    /* TRAPA #37 */
        .long   main_err    /* TRAPA #38 */
        .long   main_err    /* TRAPA #39 */
        .long   main_err    /* TRAPA #40 */
        .long   main_err    /* TRAPA #41 */
        .long   main_err    /* TRAPA #42 */
        .long   main_err    /* TRAPA #43 */
        .long   main_err    /* TRAPA #44 */
        .long   main_err    /* TRAPA #45 */
        .long   main_err    /* TRAPA #46 */
        .long   main_err    /* TRAPA #47 */
        .long   main_err    /* TRAPA #48 */
        .long   main_err    /* TRAPA #49 */
        .long   main_err    /* TRAPA #50 */
        .long   main_err    /* TRAPA #51 */
        .long   main_err    /* TRAPA #52 */
        .long   main_err    /* TRAPA #53 */
        .long   main_err    /* TRAPA #54 */
        .long   main_err    /* TRAPA #55 */
        .long   main_err    /* TRAPA #56 */
        .long   main_err    /* TRAPA #57 */
        .long   main_err    /* TRAPA #58 */
        .long   main_err    /* TRAPA #59 */
        .long   main_err    /* TRAPA #60 */
        .long   main_err    /* TRAPA #61 */
        .long   main_err    /* TRAPA #62 */
        .long   main_err    /* TRAPA #63 */
        .long   main_irq    /* Level 1 IRQ */
        .long   main_irq    /* Level 2 & 3 IRQ's */
        .long   main_irq    /* Level 4 & 5 IRQ's */
        .long   main_irq    /* PWM interupt */
        .long   main_irq    /* Command interupt */
        .long   main_irq    /* H Blank interupt */
        .long   main_irq    /* V Blank interupt */
        .long   main_irq    /* Reset Button */

! Slave Vector Base Table at 0x06000120

        .long   sstart      /* Cold Start PC */
        .long   0x0603F800  /* Cold Start SP */
        .long   sstart      /* Manual Reset PC */
        .long   0x0603F800  /* Manual Reset SP */
        .long   slav_err    /* Illegal instruction */
        .long   0x00000000  /* reserved */
        .long   slav_err    /* Invalid slot instruction */
        .long   0x20100400  /* reserved */
        .long   0x20100420  /* reserved */
        .long   slav_err    /* CPU address error */
        .long   slav_err    /* DMA address error */
        .long   slav_err    /* NMI vector */
        .long   slav_err    /* User break vector */
        .space  76          /* reserved */
        .long   slav_err    /* TRAPA #32 */
        .long   slav_err    /* TRAPA #33 */
        .long   slav_err    /* TRAPA #34 */
        .long   slav_err    /* TRAPA #35 */
        .long   slav_err    /* TRAPA #36 */
        .long   slav_err    /* TRAPA #37 */
        .long   slav_err    /* TRAPA #38 */
        .long   slav_err    /* TRAPA #39 */
        .long   slav_err    /* TRAPA #40 */
        .long   slav_err    /* TRAPA #41 */
        .long   slav_err    /* TRAPA #42 */
        .long   slav_err    /* TRAPA #43 */
        .long   slav_err    /* TRAPA #44 */
        .long   slav_err    /* TRAPA #45 */
        .long   slav_err    /* TRAPA #46 */
        .long   slav_err    /* TRAPA #47 */
        .long   slav_err    /* TRAPA #48 */
        .long   slav_err    /* TRAPA #49 */
        .long   slav_err    /* TRAPA #50 */
        .long   slav_err    /* TRAPA #51 */
        .long   slav_err    /* TRAPA #52 */
        .long   slav_err    /* TRAPA #53 */
        .long   slav_err    /* TRAPA #54 */
        .long   slav_err    /* TRAPA #55 */
        .long   slav_err    /* TRAPA #56 */
        .long   slav_err    /* TRAPA #57 */
        .long   slav_err    /* TRAPA #58 */
        .long   slav_err    /* TRAPA #59 */
        .long   slav_err    /* TRAPA #60 */
        .long   slav_err    /* TRAPA #61 */
        .long   slav_err    /* TRAPA #62 */
        .long   slav_err    /* TRAPA #63 */
        .long   slav_irq    /* Level 1 IRQ */
        .long   slav_irq    /* Level 2 & 3 IRQ's */
        .long   slav_irq    /* Level 4 & 5 IRQ's */
        .long   slav_irq    /* PWM interupt */
        .long   slav_irq    /* Command interupt */
        .long   slav_irq    /* H Blank interupt */
        .long   slav_irq    /* V Blank interupt */
        .long   slav_irq    /* Reset Button */

! The main SH2 starts here at 0x06000240

mstart:
        bra     mcont
        nop

! The slave SH2 starts here at 0x06000244

sstart:
        bra     scont
        nop

mcont:
        mov.l   _master_stk,r15
! purge cache and turn it off
        mov.l   _cache_ctl,r0
        mov     #0x10,r1
        mov.b   r1,@r0
! clear bss
        mov     #0,r0
        mov.l   _bss_dst,r1
        mov.l   _bss_end,r2
2:
        mov.b   r0,@r1
        add     #1,r1
        cmp/eq  r1,r2
        bf      2b
! wait for 68000 to finish init
        mov.l   _master_st,r0
        mov.l   _master_ok,r1
3:
        mov.l   @r0,r2
        cmp/eq  r1,r2
        bt      3b
! let Slave SH2 run
        mov.l   _slave_st,r0
        mov     #0,r1
        mov.l   r1,@r0
! purge cache and run main()
        mov.l   _cache_ctl,r0
        mov     #0x11,r1
        mov.b   r1,@r0
        mov.l   _master_go,r0
        jmp     @r0
        nop

scont:
        mov.l   _slave_stk,r15
! wait for Master SH2 and 68000 to finish init
        mov.l   _slave_st,r0
        mov.l   _slave_ok,r1
1:
        mov.l   @r0,r2
        cmp/eq  r1,r2
        bt      1b
! purge cache and run slave()
        mov.l   _cache_ctl,r0
        mov     #0x11,r1
        mov.b   r1,@r0
        mov.l   _slave_go,r0
        jmp     @r0
        nop

        .align  4
_master_stk:
        .long   0x06040000  /* Cold Start SP */
_slave_stk:
        .long   0x0603F800  /* Cold Start SP */
_cache_ctl:
        .long   0xFFFFFE92

_master_st:
        .long   0x20004020
_master_ok:
        .ascii  "M_OK"
_master_go:
        .long   _main

_slave_st:
        .long   0x20004024
_slave_ok:
        .ascii  "S_OK"
_slave_go:
        .long   _slave

        .global _bss_end
_bss_dst:
        .long   _bstart
_bss_end:
        .long   _bend


! Master exception handler

main_err:
        rte
        nop

! Master IRQ handler

main_irq:
        rte
        nop

! Slave exception handler

slav_err:
        rte
        nop

! Slave IRQ handler

slav_irq:
        rte
        nop

! Fast memcpy function - copies longs, runs from sdram for speed
! On entry: r4 = dst, r5 = src, r6 = len (in longs)

        .align 4
        .global _fast_memcpy
_fast_memcpy:
        mov.l   @r5+,r3
        mov.l   r3,@r4
        dt      r6
        bf/s    _fast_memcpy
        add     #4,r4
        rts
        nop


        .text

        .global _start
_start:

! The slave SH2 starts here - remove if define slave() in program
_slave:
        /* put cache in two-way mode */
        mov.l   _sh2_cache_ctl,r0
        mov     #0x19,r1    /* CP TW CE */
        mov.b   r1,@r0

        /* copy slave code to cache */
        mov.l   _snd_code_dst,r4
        mov.l   _snd_code_src,r5
        mov.l   _snd_code_len,r6
0:
        mov.l   @r5+,r3
        mov.l   r3,@r4
        dt      r6
        bf/s    0b
        add     #4,r4

        /* purge cache */
        mov.l   _sh2_cache_ctl,r0
        mov     #0x19,r1    /* CP TW CE */
        mov.b   r1,@r0

        /* load entry state */
        mov     #0,r10
        mov.l   _cached_vars,r11
        mov.l   _snd_vars,r12
        mov.l   _mars_sys_comm4,r13
        mov.l   _mars_pwm_ctrl,r14

        /* init PWM */
        mov.w   _pwm_ctrl_word,r0
        mov.w   r0,@r14
        mov.l   _mars_vdp_dispmode,r0
        mov.w   @r0,r1
        exts.w  r1,r1
        cmp/pz  r1
        bt      1f  /* PAL */
        mov.w   _pwm_cycle_ntsc,r0
        bra     2f
1:
        mov.w   _pwm_cycle_pal,r0
2:
        mov.w   r0,@(2,r14)

        /* clear comm4/comm6 - no sfx playing */
        mov     #0,r0
        mov.l   r0,@r13

        /* jump to code in cache */
        mov.l   _snd_code_dst,r0
        jmp     @r0
        nop

        .align  4
_sh2_cache_ctl:
        .long   0xFFFFFE92
_mars_sys_comm4:
        .long   0x20004024
_mars_pwm_ctrl:
        .long   0x20004030
_mars_vdp_dispmode:
        .long   0x20004100
_snd_vars:
        .long   _sound_vars /* in sd_32x.c */
_cached_vars:
        .long   0xC0000000

_snd_code_dst:
        .long   0xC0000100
_snd_code_src:
        .long   _slave_start_code
_snd_code_len:
        .long   (_slave_end_code - _slave_start_code) / 4

_pwm_ctrl_word:
        .word   0x0185
_pwm_cycle_ntsc:
        .word   23011361/14000
_pwm_cycle_pal:
        .word   22801467/14000


! code that will run from cache memory - entry:
! r10 = sample count (we output every sample twice)
! r11 = ptr to cached sound_vars
! r12 = ptr to sound_vars
! r13 = ptr to comm4
! r14 = ptr to mars_pwm_ctrl

        .align  4
_slave_start_code:

sound_loop:
        mov.w   @(2,r13),r0 /* get comm6 */
        cmp/eq  #0,r0
        bt      next_sample
        cmp/eq  #0xFF,r0    /* all off */
        bf      0f

! Master SH2 is requesting we kill all SFX
        mov     #0,r0
        bra     next_sample
        mov.l   r0,@r13     /* clear comm4/comm6 */

! figure out which sfx we're being told to update
0:
        mov     r0,r9
        shlr    r9
        bf      1f          /* not sfx 0 */
        mov     r11,r4      /* dst */
        bsr     update_vars
        mov     r12,r5      /* src */
1:
        shlr    r9
        bf      2f          /* not sfx 1 */
        mov     #0x10,r4
        mov     #0x10,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
2:
        shlr    r9
        bf      3f          /* not sfx 2 */
        mov     #0x20,r4
        mov     #0x20,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
3:
        shlr    r9
        bf      4f          /* not sfx 3 */
        mov     #0x30,r4
        mov     #0x30,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
4:
        shlr    r9
        bf      5f          /* not sfx 4 */
        mov     #0x40,r4
        mov     #0x40,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
5:
        shlr    r9
        bf      6f          /* not sfx 5 */
        mov     #0x50,r4
        mov     #0x50,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
6:
        shlr    r9
        bf      7f          /* not sfx 6 */
        mov     #0x60,r4
        mov     #0x60,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
7:
        shlr    r9
        bf      8f          /* not sfx 7 */
        mov     #0x70,r4
        mov     #0x70,r5
        add     r11,r4      /* dst */
        bsr     update_vars
        add     r12,r5      /* src */
8:
        mov.w   @(2,r13),r0 /* get comm6 */
        mov.w   @r13,r1     /* get comm4 */
        or      r0,r1
        mov.w   r1,@r13     /* new comm4 |= playing bits */
        mov     #0,r0
        mov.w   r0,@(2,r13) /* clear comm6 */

! fall into next sample handler

next_sample:
        mov.w   @(4,r14),r0 /* get pwm left */
        cmp/pz  r0
        bt      do_sample   /* FIFO not full */

! FIFO full - do a bit of a delay here to stay off bus enough to not slow the MASTER SH2
        mov     #100,r0
0:
        dt      r0
        bf      0b
        mov.w   @(4,r14),r0 /* get pwm left */
        cmp/pz  r0
        bf      sound_loop  /* FIFO still full */

! FIFO has space for at least one sample
do_sample:
        mov     r10,r0
        cmp/eq  #0,r0
        bf      output_sample

        mov     #0,r7
        mov     #0,r8
        mov     #1,r6       /* start with sfx 0 */
        mov.w   @r13,r9     /* get comm4 */
! check which sfx are playing
        tst     r6,r9
        bt      1f          /* not sfx 0 */
        bsr     add_sample
        mov     r11,r5      /* src */
1:
        shll    r6
        tst     r6,r9
        bt      2f          /* not sfx 1 */
        mov     #0x10,r5
        bsr     add_sample
        add     r11,r5      /* src */
2:
        shll    r6
        tst     r6,r9
        bt      3f          /* not sfx 2 */
        mov     #0x20,r5
        bsr     add_sample
        add     r11,r5      /* src */
3:
        shll    r6
        tst     r6,r9
        bt      4f          /* not sfx 3 */
        mov     #0x30,r5
        bsr     add_sample
        add     r11,r5      /* src */
4:
        shll    r6
        tst     r6,r9
        bt      5f          /* not sfx 4 */
        mov     #0x40,r5
        bsr     add_sample
        add     r11,r5      /* src */
5:
        shll    r6
        tst     r6,r9
        bt      6f          /* not sfx 5 */
        mov     #0x50,r5
        bsr     add_sample
        add     r11,r5      /* src */
6:
        shll    r6
        tst     r6,r9
        bt      7f          /* not sfx 6 */
        mov     #0x60,r5
        bsr     add_sample
        add     r11,r5      /* src */
7:
        shll    r6
        tst     r6,r9
        bt      8f          /* not sfx 7 */
        mov     #0x70,r5
        bsr     add_sample
        add     r11,r5      /* src */
8:
        /* sound is too quiet... boost it */
        shal    r7
        shal    r8
        shal    r7
        shal    r8

        mov     #50,r0
        shll2   r0
        shll2   r0
        add     #12,r0      /* 812 */
        neg     r0,r1       /* -812 */
! clamp samples
        cmp/ge  r1,r7
        bt      9f
        mov     r1,r7
9:
        cmp/ge  r7,r0
        bt      10f
        mov     r0,r7
10:
        cmp/ge  r1,r8
        bt      11f
        mov     r1,r8
11:
        cmp/ge  r8,r0
        bt      12f
        mov     r0,r8
12:
        add     #1,r0
        add     r0,r7       /* left += 812 + 1 */
        add     r0,r8       /* right += 812 + 1 */

output_sample:
        mov     r7,r0
        mov.w   r0,@(4,r14) /* set left pwm */
        mov     r8,r0
        mov.w   r0,@(6,r14) /* set right pwm */
! toggle count
        mov     #1,r0
        bra     sound_loop
        xor     r0,r10

! update cached sound vars from memory - entry:
! r4 = dst
! r5 = src

        .align  4
update_vars:
        mov     #0x40,r0
        shll8   r0
        shll16  r0
        or      r5,r0       /* r0 = src | 0x40000000 */
        mov.l   r1,@r0      /* associative purge cache line */
! copy data
        mov.l   @r5,r0
        mov.l   r0,@r4
        mov.l   @(4,r5),r0
        mov.l   r0,@(4,r4)
        mov.l   @(8,r5),r0
        mov.l   r0,@(8,r4)
        mov.l   @(12,r5),r0
        rts
        mov.l   r0,@(12,r4)

! get next sample and add to sum - entry:
! r5 = cached sfx sound vars
! r6 = sfx bit
! r7 = left sum
! r8 = right sum

        .align  4
add_sample:
        mov.l   @(4,r5),r0  /* length */
        add     #-1,r0
        cmp/pz  r0
        bt      1f
! done, clear sfx bit from comm4
        mov.w   @r13,r0     /* get comm4 */
        not     r6,r1
        and     r1,r0
        rts
        mov.w   r0,@r13     /* new comm4 */
1:
        mov.l   r0,@(4,r5)  /* update length */
        mov.l   @r5,r1      /* data pointer */
        mov.b   @r1+,r0
        mov.l   r1,@r5      /* update data pointer */
        xor     #0x80,r0
        exts.b  r0,r1
        mov     r1,r2
        mov.l   @(8,r5),r0  /* left volume */
        mul.l   r0,r1
        sts     macl,r0
        shlr16  r0
        exts.b  r0,r1
        mov.l   @(12,r5),r0  /* right volume */
        mul.l   r0,r2
        sts     macl,r0
        shlr16  r0
        exts.b  r0,r2
        add     r1,r7
        rts
        add     r2,r8

        .align  4
_slave_end_code:
