#include <malloc.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

// define UPLOAD for W3D Shareware version
//#define SPEAR
//#define SPEARDEMO
#define UPLOAD

#ifndef SPEAR

#ifndef UPLOAD
#define EXTENSION "wl6"
//
// Amount of each data item
//
#define NUMCHUNKS    149
#define NUMFONT      2
#define NUMPICS      132
#define NUMTILE8     35
#define NUMEXTERNS   13
//
// File offsets for data items
//
#define STRUCTPIC    0

#define STARTFONT    1
#define STARTPICS    3
#define STARTTILE8   135
#define STARTEXTERNS 136
#else
#define EXTENSION "wl1"
//
// Amount of each data item
//
#define NUMCHUNKS    156
#define NUMFONT      2
#define NUMPICS      144
#define NUMTILE8     35
#define NUMEXTERNS   8
//
// File offsets for data items
//
#define STRUCTPIC    0

#define STARTFONT    1
#define STARTPICS    3
#define STARTTILE8   147
#define STARTEXTERNS 148
#endif

//#include "audiowl6.h"
#define NUMSOUNDS		87
#define NUMSNDCHUNKS	288

//
// Base offsets
//
#define STARTPCSOUNDS		0
#define STARTADLIBSOUNDS	87
#define STARTMUSIC		    261

#else /* SPEAR */

#ifndef SPEARDEMO
#define EXTENSION "sod"
//
// Amount of each data item
//
#define NUMCHUNKS    169
#define NUMFONT      2
#define NUMPICS      147
#define NUMTILE8     35
#define NUMEXTERNS   18

//
// File offsets for data items
//
#define STRUCTPIC    0

#define STARTFONT    1
#define STARTPICS    3
#define STARTTILE8   150
#define STARTEXTERNS 151
#else /* SPEARDEMO */
#define EXTENSION "sdm"
//
// Amount of each data item
//
#define NUMCHUNKS    133
#define NUMFONT      2
#define NUMPICS      125
#define NUMTILE8     35
#define NUMEXTERNS   4
//
// File offsets for data items
//
#define STRUCTPIC    0

#define STARTFONT    1
#define STARTPICS    3
#define STARTTILE8   128
#define STARTEXTERNS 129
#endif /* SPEARDEMO */

//#include "audiosod.h"
#define NUMSOUNDS		81
#define NUMSNDCHUNKS	267

/* Base offsets */
#define STARTPCSOUNDS		0
#define STARTADLIBSOUNDS	81
#define STARTMUSIC		    243

#endif /* SPEAR */


#ifndef O_BINARY
#define O_BINARY 0
#endif

typedef unsigned char byte;
typedef unsigned short word;
typedef byte * memptr;

typedef struct
{
	/* 0-255 is a character, > is a pointer to a node */
	int bit0, bit1;
} huffnode;

typedef struct
{
	int width, height;
} pictabletype;

pictabletype pictable[NUMPICS];


word RLEWtag;

#define NUMMAPS		60
#define MAPPLANES	2

typedef	struct
{
	int planestart[3];
	int planelength[3];
	int width, height;
	char name[16];
} maptype;

static long mapstarts[NUMMAPS];
static word	*mapsegs[NUMMAPS][MAPPLANES];
static maptype	*mapheaderseg[NUMMAPS];


byte	*grsegs[NUMCHUNKS];

static int csize[NUMCHUNKS];

static int *grstarts;	/* array of offsets in vgagraph */

static huffnode grhuffman[256];

static int grhandle = -1;	/* handle to VGAGRAPH */


//
// sprite constants
//

enum {
		SPR_DEMO,
		SPR_DEATHCAM,
//
// static sprites
//
		SPR_STAT_0,SPR_STAT_1,SPR_STAT_2,SPR_STAT_3,
		SPR_STAT_4,SPR_STAT_5,SPR_STAT_6,SPR_STAT_7,

		SPR_STAT_8,SPR_STAT_9,SPR_STAT_10,SPR_STAT_11,
		SPR_STAT_12,SPR_STAT_13,SPR_STAT_14,SPR_STAT_15,

		SPR_STAT_16,SPR_STAT_17,SPR_STAT_18,SPR_STAT_19,
		SPR_STAT_20,SPR_STAT_21,SPR_STAT_22,SPR_STAT_23,

		SPR_STAT_24,SPR_STAT_25,SPR_STAT_26,SPR_STAT_27,
		SPR_STAT_28,SPR_STAT_29,SPR_STAT_30,SPR_STAT_31,

		SPR_STAT_32,SPR_STAT_33,SPR_STAT_34,SPR_STAT_35,
		SPR_STAT_36,SPR_STAT_37,SPR_STAT_38,SPR_STAT_39,

		SPR_STAT_40,SPR_STAT_41,SPR_STAT_42,SPR_STAT_43,
		SPR_STAT_44,SPR_STAT_45,SPR_STAT_46,SPR_STAT_47,

#ifdef SPEAR
		SPR_STAT_48,SPR_STAT_49,SPR_STAT_50,SPR_STAT_51,
#endif

//
// guard
//
		SPR_GRD_S_1,SPR_GRD_S_2,SPR_GRD_S_3,SPR_GRD_S_4,
		SPR_GRD_S_5,SPR_GRD_S_6,SPR_GRD_S_7,SPR_GRD_S_8,

		SPR_GRD_W1_1,SPR_GRD_W1_2,SPR_GRD_W1_3,SPR_GRD_W1_4,
		SPR_GRD_W1_5,SPR_GRD_W1_6,SPR_GRD_W1_7,SPR_GRD_W1_8,

		SPR_GRD_W2_1,SPR_GRD_W2_2,SPR_GRD_W2_3,SPR_GRD_W2_4,
		SPR_GRD_W2_5,SPR_GRD_W2_6,SPR_GRD_W2_7,SPR_GRD_W2_8,

		SPR_GRD_W3_1,SPR_GRD_W3_2,SPR_GRD_W3_3,SPR_GRD_W3_4,
		SPR_GRD_W3_5,SPR_GRD_W3_6,SPR_GRD_W3_7,SPR_GRD_W3_8,

		SPR_GRD_W4_1,SPR_GRD_W4_2,SPR_GRD_W4_3,SPR_GRD_W4_4,
		SPR_GRD_W4_5,SPR_GRD_W4_6,SPR_GRD_W4_7,SPR_GRD_W4_8,

		SPR_GRD_PAIN_1,SPR_GRD_DIE_1,SPR_GRD_DIE_2,SPR_GRD_DIE_3,
		SPR_GRD_PAIN_2,SPR_GRD_DEAD,

		SPR_GRD_SHOOT1,SPR_GRD_SHOOT2,SPR_GRD_SHOOT3,

//
// dogs
//
		SPR_DOG_W1_1,SPR_DOG_W1_2,SPR_DOG_W1_3,SPR_DOG_W1_4,
		SPR_DOG_W1_5,SPR_DOG_W1_6,SPR_DOG_W1_7,SPR_DOG_W1_8,

		SPR_DOG_W2_1,SPR_DOG_W2_2,SPR_DOG_W2_3,SPR_DOG_W2_4,
		SPR_DOG_W2_5,SPR_DOG_W2_6,SPR_DOG_W2_7,SPR_DOG_W2_8,

		SPR_DOG_W3_1,SPR_DOG_W3_2,SPR_DOG_W3_3,SPR_DOG_W3_4,
		SPR_DOG_W3_5,SPR_DOG_W3_6,SPR_DOG_W3_7,SPR_DOG_W3_8,

		SPR_DOG_W4_1,SPR_DOG_W4_2,SPR_DOG_W4_3,SPR_DOG_W4_4,
		SPR_DOG_W4_5,SPR_DOG_W4_6,SPR_DOG_W4_7,SPR_DOG_W4_8,

		SPR_DOG_DIE_1,SPR_DOG_DIE_2,SPR_DOG_DIE_3,SPR_DOG_DEAD,
		SPR_DOG_JUMP1,SPR_DOG_JUMP2,SPR_DOG_JUMP3,



//
// ss
//
		SPR_SS_S_1,SPR_SS_S_2,SPR_SS_S_3,SPR_SS_S_4,
		SPR_SS_S_5,SPR_SS_S_6,SPR_SS_S_7,SPR_SS_S_8,

		SPR_SS_W1_1,SPR_SS_W1_2,SPR_SS_W1_3,SPR_SS_W1_4,
		SPR_SS_W1_5,SPR_SS_W1_6,SPR_SS_W1_7,SPR_SS_W1_8,

		SPR_SS_W2_1,SPR_SS_W2_2,SPR_SS_W2_3,SPR_SS_W2_4,
		SPR_SS_W2_5,SPR_SS_W2_6,SPR_SS_W2_7,SPR_SS_W2_8,

		SPR_SS_W3_1,SPR_SS_W3_2,SPR_SS_W3_3,SPR_SS_W3_4,
		SPR_SS_W3_5,SPR_SS_W3_6,SPR_SS_W3_7,SPR_SS_W3_8,

		SPR_SS_W4_1,SPR_SS_W4_2,SPR_SS_W4_3,SPR_SS_W4_4,
		SPR_SS_W4_5,SPR_SS_W4_6,SPR_SS_W4_7,SPR_SS_W4_8,

		SPR_SS_PAIN_1,SPR_SS_DIE_1,SPR_SS_DIE_2,SPR_SS_DIE_3,
		SPR_SS_PAIN_2,SPR_SS_DEAD,

		SPR_SS_SHOOT1,SPR_SS_SHOOT2,SPR_SS_SHOOT3,

//
// mutant
//
		SPR_MUT_S_1,SPR_MUT_S_2,SPR_MUT_S_3,SPR_MUT_S_4,
		SPR_MUT_S_5,SPR_MUT_S_6,SPR_MUT_S_7,SPR_MUT_S_8,

		SPR_MUT_W1_1,SPR_MUT_W1_2,SPR_MUT_W1_3,SPR_MUT_W1_4,
		SPR_MUT_W1_5,SPR_MUT_W1_6,SPR_MUT_W1_7,SPR_MUT_W1_8,

		SPR_MUT_W2_1,SPR_MUT_W2_2,SPR_MUT_W2_3,SPR_MUT_W2_4,
		SPR_MUT_W2_5,SPR_MUT_W2_6,SPR_MUT_W2_7,SPR_MUT_W2_8,

		SPR_MUT_W3_1,SPR_MUT_W3_2,SPR_MUT_W3_3,SPR_MUT_W3_4,
		SPR_MUT_W3_5,SPR_MUT_W3_6,SPR_MUT_W3_7,SPR_MUT_W3_8,

		SPR_MUT_W4_1,SPR_MUT_W4_2,SPR_MUT_W4_3,SPR_MUT_W4_4,
		SPR_MUT_W4_5,SPR_MUT_W4_6,SPR_MUT_W4_7,SPR_MUT_W4_8,

		SPR_MUT_PAIN_1,SPR_MUT_DIE_1,SPR_MUT_DIE_2,SPR_MUT_DIE_3,
		SPR_MUT_PAIN_2,SPR_MUT_DIE_4,SPR_MUT_DEAD,

		SPR_MUT_SHOOT1,SPR_MUT_SHOOT2,SPR_MUT_SHOOT3,SPR_MUT_SHOOT4,

//
// officer
//
		SPR_OFC_S_1,SPR_OFC_S_2,SPR_OFC_S_3,SPR_OFC_S_4,
		SPR_OFC_S_5,SPR_OFC_S_6,SPR_OFC_S_7,SPR_OFC_S_8,

		SPR_OFC_W1_1,SPR_OFC_W1_2,SPR_OFC_W1_3,SPR_OFC_W1_4,
		SPR_OFC_W1_5,SPR_OFC_W1_6,SPR_OFC_W1_7,SPR_OFC_W1_8,

		SPR_OFC_W2_1,SPR_OFC_W2_2,SPR_OFC_W2_3,SPR_OFC_W2_4,
		SPR_OFC_W2_5,SPR_OFC_W2_6,SPR_OFC_W2_7,SPR_OFC_W2_8,

		SPR_OFC_W3_1,SPR_OFC_W3_2,SPR_OFC_W3_3,SPR_OFC_W3_4,
		SPR_OFC_W3_5,SPR_OFC_W3_6,SPR_OFC_W3_7,SPR_OFC_W3_8,

		SPR_OFC_W4_1,SPR_OFC_W4_2,SPR_OFC_W4_3,SPR_OFC_W4_4,
		SPR_OFC_W4_5,SPR_OFC_W4_6,SPR_OFC_W4_7,SPR_OFC_W4_8,

		SPR_OFC_PAIN_1,SPR_OFC_DIE_1,SPR_OFC_DIE_2,SPR_OFC_DIE_3,
		SPR_OFC_PAIN_2,SPR_OFC_DIE_4,SPR_OFC_DEAD,

		SPR_OFC_SHOOT1,SPR_OFC_SHOOT2,SPR_OFC_SHOOT3,

#ifndef SPEAR
//
// ghosts
//
		SPR_BLINKY_W1,SPR_BLINKY_W2,SPR_PINKY_W1,SPR_PINKY_W2,
		SPR_CLYDE_W1,SPR_CLYDE_W2,SPR_INKY_W1,SPR_INKY_W2,

//
// hans
//
		SPR_BOSS_W1,SPR_BOSS_W2,SPR_BOSS_W3,SPR_BOSS_W4,
		SPR_BOSS_SHOOT1,SPR_BOSS_SHOOT2,SPR_BOSS_SHOOT3,SPR_BOSS_DEAD,

		SPR_BOSS_DIE1,SPR_BOSS_DIE2,SPR_BOSS_DIE3,

//
// schabbs
//
		SPR_SCHABB_W1,SPR_SCHABB_W2,SPR_SCHABB_W3,SPR_SCHABB_W4,
		SPR_SCHABB_SHOOT1,SPR_SCHABB_SHOOT2,

		SPR_SCHABB_DIE1,SPR_SCHABB_DIE2,SPR_SCHABB_DIE3,SPR_SCHABB_DEAD,
		SPR_HYPO1,SPR_HYPO2,SPR_HYPO3,SPR_HYPO4,

//
// fake
//
		SPR_FAKE_W1,SPR_FAKE_W2,SPR_FAKE_W3,SPR_FAKE_W4,
		SPR_FAKE_SHOOT,SPR_FIRE1,SPR_FIRE2,

		SPR_FAKE_DIE1,SPR_FAKE_DIE2,SPR_FAKE_DIE3,SPR_FAKE_DIE4,
		SPR_FAKE_DIE5,SPR_FAKE_DEAD,

//
// hitler
//
		SPR_MECHA_W1,SPR_MECHA_W2,SPR_MECHA_W3,SPR_MECHA_W4,
		SPR_MECHA_SHOOT1,SPR_MECHA_SHOOT2,SPR_MECHA_SHOOT3,SPR_MECHA_DEAD,

		SPR_MECHA_DIE1,SPR_MECHA_DIE2,SPR_MECHA_DIE3,

		SPR_HITLER_W1,SPR_HITLER_W2,SPR_HITLER_W3,SPR_HITLER_W4,
		SPR_HITLER_SHOOT1,SPR_HITLER_SHOOT2,SPR_HITLER_SHOOT3,SPR_HITLER_DEAD,

		SPR_HITLER_DIE1,SPR_HITLER_DIE2,SPR_HITLER_DIE3,SPR_HITLER_DIE4,
		SPR_HITLER_DIE5,SPR_HITLER_DIE6,SPR_HITLER_DIE7,

//
// giftmacher
//
		SPR_GIFT_W1,SPR_GIFT_W2,SPR_GIFT_W3,SPR_GIFT_W4,
		SPR_GIFT_SHOOT1,SPR_GIFT_SHOOT2,

		SPR_GIFT_DIE1,SPR_GIFT_DIE2,SPR_GIFT_DIE3,SPR_GIFT_DEAD,
#endif
//
// Rocket, smoke and small explosion
//
		SPR_ROCKET_1,SPR_ROCKET_2,SPR_ROCKET_3,SPR_ROCKET_4,
		SPR_ROCKET_5,SPR_ROCKET_6,SPR_ROCKET_7,SPR_ROCKET_8,

		SPR_SMOKE_1,SPR_SMOKE_2,SPR_SMOKE_3,SPR_SMOKE_4,
		SPR_BOOM_1,SPR_BOOM_2,SPR_BOOM_3,

//
// Angel of Death's DeathSparks(tm)
//
#ifdef SPEAR
		SPR_HROCKET_1,SPR_HROCKET_2,SPR_HROCKET_3,SPR_HROCKET_4,
		SPR_HROCKET_5,SPR_HROCKET_6,SPR_HROCKET_7,SPR_HROCKET_8,

		SPR_HSMOKE_1,SPR_HSMOKE_2,SPR_HSMOKE_3,SPR_HSMOKE_4,
		SPR_HBOOM_1,SPR_HBOOM_2,SPR_HBOOM_3,

		SPR_SPARK1,SPR_SPARK2,SPR_SPARK3,SPR_SPARK4,
#endif

#ifndef SPEAR
//
// gretel
//
		SPR_GRETEL_W1,SPR_GRETEL_W2,SPR_GRETEL_W3,SPR_GRETEL_W4,
		SPR_GRETEL_SHOOT1,SPR_GRETEL_SHOOT2,SPR_GRETEL_SHOOT3,SPR_GRETEL_DEAD,

		SPR_GRETEL_DIE1,SPR_GRETEL_DIE2,SPR_GRETEL_DIE3,

//
// fat face
//
		SPR_FAT_W1,SPR_FAT_W2,SPR_FAT_W3,SPR_FAT_W4,
		SPR_FAT_SHOOT1,SPR_FAT_SHOOT2,SPR_FAT_SHOOT3,SPR_FAT_SHOOT4,

		SPR_FAT_DIE1,SPR_FAT_DIE2,SPR_FAT_DIE3,SPR_FAT_DEAD,

//
// bj
//
		SPR_BJ_W1,SPR_BJ_W2,SPR_BJ_W3,SPR_BJ_W4,
		SPR_BJ_JUMP1,SPR_BJ_JUMP2,SPR_BJ_JUMP3,SPR_BJ_JUMP4,
#else
//
// THESE ARE FOR 'SPEAR OF DESTINY'
//

//
// Trans Grosse
//
		SPR_TRANS_W1,SPR_TRANS_W2,SPR_TRANS_W3,SPR_TRANS_W4,
		SPR_TRANS_SHOOT1,SPR_TRANS_SHOOT2,SPR_TRANS_SHOOT3,SPR_TRANS_DEAD,

		SPR_TRANS_DIE1,SPR_TRANS_DIE2,SPR_TRANS_DIE3,

//
// Wilhelm
//
		SPR_WILL_W1,SPR_WILL_W2,SPR_WILL_W3,SPR_WILL_W4,
		SPR_WILL_SHOOT1,SPR_WILL_SHOOT2,SPR_WILL_SHOOT3,SPR_WILL_SHOOT4,

		SPR_WILL_DIE1,SPR_WILL_DIE2,SPR_WILL_DIE3,SPR_WILL_DEAD,

//
// UberMutant
//
		SPR_UBER_W1,SPR_UBER_W2,SPR_UBER_W3,SPR_UBER_W4,
		SPR_UBER_SHOOT1,SPR_UBER_SHOOT2,SPR_UBER_SHOOT3,SPR_UBER_SHOOT4,

		SPR_UBER_DIE1,SPR_UBER_DIE2,SPR_UBER_DIE3,SPR_UBER_DIE4,
		SPR_UBER_DEAD,

//
// Death Knight
//
		SPR_DEATH_W1,SPR_DEATH_W2,SPR_DEATH_W3,SPR_DEATH_W4,
		SPR_DEATH_SHOOT1,SPR_DEATH_SHOOT2,SPR_DEATH_SHOOT3,SPR_DEATH_SHOOT4,

		SPR_DEATH_DIE1,SPR_DEATH_DIE2,SPR_DEATH_DIE3,SPR_DEATH_DIE4,
		SPR_DEATH_DIE5,SPR_DEATH_DIE6,SPR_DEATH_DEAD,

//
// Ghost
//
		SPR_SPECTRE_W1,SPR_SPECTRE_W2,SPR_SPECTRE_W3,SPR_SPECTRE_W4,
		SPR_SPECTRE_F1,SPR_SPECTRE_F2,SPR_SPECTRE_F3,SPR_SPECTRE_F4,

//
// Angel of Death
//
		SPR_ANGEL_W1,SPR_ANGEL_W2,SPR_ANGEL_W3,SPR_ANGEL_W4,
		SPR_ANGEL_SHOOT1,SPR_ANGEL_SHOOT2,SPR_ANGEL_TIRED1,SPR_ANGEL_TIRED2,

		SPR_ANGEL_DIE1,SPR_ANGEL_DIE2,SPR_ANGEL_DIE3,SPR_ANGEL_DIE4,
		SPR_ANGEL_DIE5,SPR_ANGEL_DIE6,SPR_ANGEL_DIE7,SPR_ANGEL_DEAD,

#endif

//
// player attack frames
//
		SPR_KNIFEREADY,SPR_KNIFEATK1,SPR_KNIFEATK2,SPR_KNIFEATK3,
		SPR_KNIFEATK4,

		SPR_PISTOLREADY,SPR_PISTOLATK1,SPR_PISTOLATK2,SPR_PISTOLATK3,
		SPR_PISTOLATK4,

		SPR_MACHINEGUNREADY,SPR_MACHINEGUNATK1,SPR_MACHINEGUNATK2,MACHINEGUNATK3,
		SPR_MACHINEGUNATK4,

		SPR_CHAINREADY,SPR_CHAINATK1,SPR_CHAINATK2,SPR_CHAINATK3,
		SPR_CHAINATK4, SPR_NULLSPRITE, SPR_TOTAL
};

static byte *spritegfx[SPR_TOTAL];

int ChunksInFile, PMSpriteStart, PMSoundStart;

#define	PM_GetSpritePage(v)	PM_GetPage(PMSpriteStart + (v))

memptr *PMPages;
int *PMOffsets;
int *PMLengths;


static void process_audiohed(void);
static void process_maphead(void);
static void process_gamemaps(void);
static void process_vgahead(void);
static void process_vgagraph(void);
static void process_vswap(void);

int main(void)
{
    // process audiohed file
    process_audiohed();
    // we're currently leaving this one alone
    //process_audiot();

    // process maphead file
    process_maphead();
    // process gamemaps file
    process_gamemaps();

    // process vgahead file
    process_vgahead();
    // process vgagraph file
    process_vgagraph();

    // process vswap file
    process_vswap();

    return 0;
}

long filelength(int handle)
{
	struct stat buf;

	if (fstat(handle, &buf) == -1) {
		printf("error getting filelength\n");
		return 0;
	}

	return buf.st_size;
}

int OpenWrite(char *fn)
{
	int fp;

	fp = open(fn, O_CREAT|O_WRONLY|O_TRUNC|O_BINARY, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
	return fp;
}

void CloseWrite(int fp)
{
	close(fp);
}

int WriteInt8(int fp, byte d)
{
	return write(fp, &d, 1);
}

int WriteInt16(int fp, int16_t d)
{
	unsigned short b = ((unsigned short)d >> 8) | ((unsigned short)d << 8);

	return write(fp, &b, 2) / 2;
}

int WriteInt32(int fp, int32_t d)
{
	unsigned int b = ((unsigned int)(d & 0xFF000000) >> 24) |
		        ((unsigned int)(d & 0x00FF0000) >>  8) |
		        ((unsigned int)(d & 0x0000FF00) <<  8) |
		        ((unsigned int)(d & 0x000000FF) << 24);

	return write(fp, &b, 4) / 4;
}

int WriteBytes(int fp, byte *d, int len)
{
	return write(fp, d, len);
}

int OpenRead(char *fn)
{
	int fp;

	fp = open(fn, O_RDONLY | O_BINARY);

	return fp;
}

void CloseRead(int fp)
{
	close(fp);
}

int ReadSeek(int fp, int offset, int whence)
{
	return lseek(fp, offset, whence);
}

int ReadLength(int fp)
{
	return filelength(fp);
}

int8_t ReadInt8(int fp)
{
	byte d[1];

	read(fp, d, 1);

	return d[0];
}

int16_t ReadInt16(int fp)
{
	byte d[2];

	read(fp, d, 2);

	return (d[0]) | (d[1] << 8);
}

int32_t ReadInt32(int fp)
{
	byte d[4];

	read(fp, d, 4);

	return (d[0]) | (d[1] << 8) | (d[2] << 16) | (d[3] << 24);
}

int ReadBytes(int fp, byte *d, int len)
{
	return read(fp, d, len);
}

/*
======================
=
= CAL_CarmackExpand
= Length is the length of the EXPANDED data
=
= Note: This function happens to implicity swap words' bytes around.
=       For maps, this happens to be the desired effect.
=
======================
*/

#define NEARTAG	0xa7
#define FARTAG	0xa8

void CAL_CarmackExpand(byte *source, word *dest, word length)
{
	unsigned int offset;
	word *copyptr, *outptr;
	byte chhigh, chlow, *inptr;

	length /= 2;

	inptr = source;
	outptr = dest;

	while (length) {
		chlow = *inptr++; /* count */
		chhigh = *inptr++;

		if (chhigh == NEARTAG) {
			if (!chlow) {
				/* have to insert a word containing the tag byte */
				*outptr++ = (chhigh << 8) | *inptr;
				inptr++;

				length--;
			} else {
				offset = *inptr;
				inptr++;

				copyptr = outptr - offset;

				length -= chlow;
				while (chlow--)
					*outptr++ = *copyptr++;
			}
		} else if (chhigh == FARTAG) {
			if (!chlow) {
				/* have to insert a word containing the tag byte */
				*outptr++ = (chhigh << 8) | *inptr;
				inptr++;

				length--;
			} else {
				offset = *inptr | (*(inptr+1) << 8);
				inptr += 2;

				copyptr = dest + offset;
				length -= chlow;
				while (chlow--)
					*outptr++ = *copyptr++;
			}
		} else {
			*outptr++ = (chhigh << 8) | chlow;
			length--;
		}
	}
}

/*
======================
=
= CA_RLEWexpand
= length is EXPANDED length
=
======================
*/

void CA_RLEWexpand(word *source, word *dest, long length, word rlewtag)
{
	word value, count, i;
	word *end = dest + length / 2;

	/* expand it */
	do {
		value = *source++;

		if (value != rlewtag)
			/* uncompressed */
			*dest++ = value;
		else {
			/* compressed string */
			count = *source++;

			value = *source++;
			for (i = 0; i < count; i++)
				*dest++ = value;
		}
	} while (dest < end);
}


void VL_DeModeXize(byte *buf, int width, int height)
{
	byte *mem, *ptr, *destline;
	int plane, x, y;

	if (width & 3) {
		printf("Not divisible by 4?\n");
		return;
	}

	//MM_GetPtr((memptr)&mem, width * height);
	mem = malloc(width * height);

	ptr = buf;

	for (plane = 0; plane < 4; plane++) {
		destline = mem;
		for (y = 0; y < height; y++) {
			for (x = 0; x < width / 4; x++)
				*(destline + x*4 + plane) = *ptr++;
			destline += width;
		}
	}

	memcpy(buf, mem, width * height);

	//MM_FreePtr((memptr)&mem);
	free(mem);
}

/*
======================
=
= CAL_HuffExpand
= Length is the length of the EXPANDED data
=
======================
*/

/* From Ryan C. Gordon -- ryan_gordon@hotmail.com */
void CAL_HuffExpand(byte *source, byte *dest, int length, huffnode *htable)
{
	huffnode *headptr;
	huffnode *nodeon;
	byte      mask = 0x01;
	word      path;
	byte     *endoff = dest + length;

	nodeon = headptr = &htable[254];

	do {
		if (*source & mask)
			path = nodeon->bit1;
        else
			path = nodeon->bit0;
   		mask <<= 1;
   		mask &= 0xFF;
        if (mask == 0x00) {
			mask = 0x01;
			source++;
        }
		if (path < 256) {
			*dest = (byte)path;
			dest++;
			nodeon = headptr;
		} else
			nodeon = &htable[path - 256];
	} while (dest != endoff);
}

/*
======================
=
= CAL_ExpandGrChunk
=
= Does whatever is needed with a pointer to a compressed chunk
=
======================
*/

static void CAL_ExpandGrChunk(int chunk, byte *source)
{
	int tilecount = 0, i;
	int expanded;

	int width = 0, height = 0;

	if (chunk >= STARTTILE8 && chunk < STARTEXTERNS)
	{
	/* expanded sizes of tile8 are implicit */
		expanded = 8*8*NUMTILE8;
		width = 8;
		height = 8;
		tilecount = NUMTILE8;
	} else if (chunk >= STARTPICS && chunk < STARTTILE8) {
		width = pictable[chunk - STARTPICS].width;
		height = pictable[chunk - STARTPICS].height;
		expanded = source[0]|(source[1]<<8)|(source[2]<<16)|(source[3]<<24);
		source += 4;
	} else {
	/* everything else has an explicit size longword */
		expanded = source[0]|(source[1]<<8)|(source[2]<<16)|(source[3]<<24);
		source += 4;
	}

/* allocate final space and decompress it */
	//MM_GetPtr((void *)&grsegs[chunk], expanded);
	grsegs[chunk] = malloc(expanded);
	csize[chunk] = expanded;
	CAL_HuffExpand(source, grsegs[chunk], expanded, grhuffman);
	if (width && height) {
		if (tilecount) {
			for (i = 0; i < tilecount; i++)
				VL_DeModeXize(grsegs[chunk]+(width*height)*i, width, height);
		} else
			VL_DeModeXize(grsegs[chunk], width, height);
	}
	printf(" %d\n", expanded);
}

/*
======================
=
= CA_CacheGrChunk
=
= Makes sure a given chunk is in memory, loading it if needed
=
======================
*/

void CA_CacheGrChunk(int chunk)
{
	int pos, compressed;
	byte *source;

	if (grhandle == -1)
		return;

	if (grsegs[chunk]) {
		return;
	}

/* load the chunk into a buffer */
	pos = grstarts[chunk];

	compressed = grstarts[chunk+1]-pos;
	printf("Chunk %d expanded %d from %d to", chunk, pos, compressed);

	ReadSeek(grhandle, pos, SEEK_SET);

	//MM_GetPtr((memptr)&source, compressed);
	source = malloc(compressed);
	ReadBytes(grhandle, source, compressed);

	CAL_ExpandGrChunk(chunk, source);

	//MM_FreePtr((memptr)&source);
	free(source);
}

/*
======================
=
= CAL_SetupGrFile
=
======================
*/

static void CAL_SetupGrFile()
{
	int handle;
	byte *grtemp;
	int i, pos;

/* load vgadict.ext (huffman dictionary for graphics files) */

	handle = OpenRead("Wolf_3D_SW_ORG/vgadict.wl1");
	if (handle == -1) {
	    printf("Couldn't open vgadict.wl1\n");
	    return;
    }
    printf("Reading vgadict.wl1\n");

	for (i = 0; i < 256; i++) {
		grhuffman[i].bit0 = ReadInt16(handle);
		grhuffman[i].bit1 = ReadInt16(handle);
	}

	CloseRead(handle);

/* load the data offsets from vgahead.ext */
	//MM_GetPtr((memptr)&grstarts, (NUMCHUNKS+1)*4);
	grstarts = malloc((NUMCHUNKS+1)*4);
	//MM_GetPtr((memptr)&grtemp, (NUMCHUNKS+1)*3);
	grtemp = malloc((NUMCHUNKS+1)*3);

    memset(grsegs, 0, NUMCHUNKS * sizeof(byte *));

	handle = OpenRead("Wolf_3D_SW_ORG/vgahead.wl1");
	if (handle == -1) {
	    printf("Couldn't open vgahead.wl1\n");
	    return;
    }
    printf("Reading vgahead.wl1\n");

	ReadBytes(handle, grtemp, (NUMCHUNKS+1)*3);

	for (i = 0; i < NUMCHUNKS+1; i++)
		grstarts[i] = (grtemp[i*3+0]<<0)|(grtemp[i*3+1]<<8)|(grtemp[i*3+2]<<16);

	//MM_FreePtr((memptr)&grtemp);
	free(grtemp);

	CloseRead(handle);

/* Open the graphics file, leaving it open until the game is finished */
	grhandle = OpenRead("Wolf_3D_SW_ORG/vgagraph.wl1");
	if (grhandle == -1) {
	    printf("Couldn't open vgagraph.wl1\n");
	    return;
    }
    printf("Reading vgagraph.wl1\n");

/* load the pic headers into pictable */
	CA_CacheGrChunk(STRUCTPIC);

	grtemp = grsegs[STRUCTPIC];
	for (i = 0; i < NUMPICS; i++) {
		pictable[i].width = grtemp[i*4+0] | (grtemp[i*4+1] << 8);
		pictable[i].height = grtemp[i*4+2] | (grtemp[i*4+3] << 8);
	}

/* cache all gr chunks */
	for (i = 0; i < NUMCHUNKS; i++)
    	CA_CacheGrChunk(i);

    CloseRead(grhandle);

/* write all uncompressed gr chunks */

    handle = OpenWrite("vgahead.wl1");
	if (handle == -1) {
	    printf("Couldn't open vgahead.wl1 to write\n");
	    return;
    }
    pos = 0;
	for (i = 0; i < NUMCHUNKS+1; i++) {
	    // write the offset to each chunk += size of previous chunk
  	    WriteInt8(handle, (pos>>0) & 0xFF);
        WriteInt8(handle, (pos>>8) & 0xFF);
        WriteInt8(handle, (pos>>16) & 0xFF);
        pos += csize[i];
    }
    CloseWrite(handle);

    handle = OpenWrite("vgagraph.wl1");
	if (handle == -1) {
	    printf("Couldn't open vgagraph.wl1 to write\n");
	    return;
    }
	for (i = 0; i < NUMCHUNKS+1; i++) {
	    // write the data for each chunk
        WriteBytes(handle, grsegs[i], csize[i]);
    }
    CloseWrite(handle);
}

/*
======================
=
= CA_CacheMap
=
======================
*/

void CA_CacheMap(int mapnum, int maphandle)
{
	long pos,compressed;
	int plane;
	byte *source;
	memptr buffer2seg;
	long expanded;

/* load the planes into the already allocated buffers */

	for (plane = 0; plane < MAPPLANES; plane++)
	{
		pos = mapheaderseg[mapnum]->planestart[plane];
		compressed = mapheaderseg[mapnum]->planelength[plane];

		ReadSeek(maphandle, pos, SEEK_SET);

		//MM_GetPtr((void *)&source, compressed);
        source = malloc(compressed);
		ReadBytes(maphandle, (byte *)source, compressed);
        printf(" Read compressed map (%d)\n", compressed);

		expanded = source[0] | (source[1] << 8);
		//MM_GetPtr(&buffer2seg, expanded);
		buffer2seg = malloc(expanded);

/* NOTE: CarmackExpand implicitly fixes endianness, a RLEW'd only map
         would (likely) need to be swapped in CA_RLEWexpand

         Wolfenstein 3D/Spear of Destiny maps are always Carmack'd so this
         case is OK.  CA_RLEWexpand would need to be adjusted for Blake Stone
         and the like.
*/
		CAL_CarmackExpand(source+2, (word *)buffer2seg, expanded);
        printf(" Expanded map (%d)\n", expanded);
		//MM_FreePtr((void *)&source);
		free(source);

        mapsegs[mapnum][plane] = malloc(64*64*2);
		expanded = 64*64*2;
		CA_RLEWexpand(((word *)buffer2seg)+1, mapsegs[mapnum][plane], expanded, RLEWtag);
        printf(" Decompressed map #%d\n", mapnum);
		//MM_FreePtr(&buffer2seg);
		free(buffer2seg);
	}
}


memptr PM_GetPage(int pagenum)
{
	if (pagenum >= ChunksInFile) {
		printf("PM_GetPage: Invalid page request");
		return NULL;
    }

	return PMPages[pagenum];
}

static void DeCompileSprite(int shapenum)
{
	byte *ptr;
	byte *buf;
	byte *cmdptr;
	byte *pixels;
	int yoff;
	int y, y0, y1;
	int x, left, right;
	int cmd;

	//MM_GetPtr((void *)&buf, 64 * 64);
	buf = malloc(64*64);

	memset(buf, 255, 64 * 64);

    printf(" Getting sprite page... ");
	ptr = PM_GetSpritePage(shapenum);
    printf("%x\n", ptr);

	/* left = ptr[0] | (ptr[1] << 8); */
	left = ptr[0];
	/* right = ptr[2] | (ptr[3] << 8); */
	right = ptr[2];

	cmdptr = &ptr[4];

	for (x = left; x <= right; x++) {
		cmd = cmdptr[0] | (cmdptr[1] << 8);
		cmdptr += 2;

		/* while (ptr[cmd+0] | (ptr[cmd+1] << 8)) { */
		while (ptr[cmd+0]) {
			/* y1 = (ptr[cmd+0] | (ptr[cmd+1] << 8)) / 2; */
			y1 = ptr[cmd+0] / 2;
			yoff = (int16_t)(ptr[cmd+2] | (ptr[cmd+3] << 8));
			/* y0 = (ptr[cmd+4] | (ptr[cmd+5] << 8)) / 2; */
			y0 = ptr[cmd+4] / 2;

			pixels = &ptr[y0 + yoff];

			for (y = y0; y < y1; y++) {
				/* *(buf + x + (y*64)) = *pixels; */
				*(buf + (x*64) + y) = *pixels;
				pixels++;
			}

			cmd += 6;
		}
	}
    printf(" sprite decompiled\n");

	spritegfx[shapenum] = buf;
}



static void process_audiohed(void)
{
    int ihandle, ohandle;
	long length;
	char iname[80];
	char oname[80];
	int i, v;

	strcpy(iname, "data/original/audiohed.");
	strcat(iname, EXTENSION);
	strcpy(oname, "romfiles/audiohed.");
	strcat(oname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }

    ohandle = OpenWrite(oname);
	if (ohandle == -1) {
	    printf("Couldn't open %s to write\n", oname);
	    CloseRead(ihandle);
	    return;
    }

	length = ReadLength(ihandle);
	ReadSeek(ihandle, 0, SEEK_SET);

	//MM_GetPtr((memptr)&audiostarts, length);

    // read entry little-endian, write entry big-endian
	for (i = 0; i < (length/4); i++) {
		v = ReadInt32(ihandle);
		WriteInt32(ohandle, v);
    }

	CloseRead(ihandle);
	CloseWrite(ohandle);
}

static void process_maphead(void)
{
    int ihandle, ohandle;
	long pos;
	char iname[80];
	char oname[80];
	int i, j;

	strcpy(iname, "data/original/maphead.");
	strcat(iname, EXTENSION);
	strcpy(oname, "romfiles/maphead.");
	strcat(oname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }

    ohandle = OpenWrite(oname);
	if (ohandle == -1) {
	    printf("Couldn't open %s to write\n", oname);
	    CloseRead(ihandle);
	    return;
    }

    RLEWtag = ReadInt16(ihandle);

	for (i = 0, j = 0; i < NUMMAPS; i++)
	{
		pos = ReadInt32(ihandle);
		mapstarts[i] = pos;
		if (pos == 0)
    		WriteInt32(ohandle, 0);
        else
    		WriteInt32(ohandle, 4+sizeof(maptype)*j++);
	}

	CloseRead(ihandle);
	CloseWrite(ohandle);
}

static void process_gamemaps(void)
{
    int ihandle, ohandle;
	long pos;
	char iname[80];
	char oname[80];
	int i, j, k, plane;

	strcpy(iname, "data/original/gamemaps.");
	strcat(iname, EXTENSION);
	strcpy(oname, "romfiles/gamemaps.");
	strcat(oname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }

    ohandle = OpenWrite(oname);
	if (ohandle == -1) {
	    printf("Couldn't open %s to write\n", oname);
	    CloseRead(ihandle);
	    return;
    }

	for (i = 0, j = 0; i < NUMMAPS; i++)
	{
		pos = mapstarts[i];
		if (pos == 0)
			continue;

        j++;
        printf("Processing map #%d\n", j);

        mapheaderseg[i] = (maptype *)malloc(sizeof(maptype));
		ReadSeek(ihandle, pos, SEEK_SET);

		mapheaderseg[i]->planestart[0] = ReadInt32(ihandle);
		mapheaderseg[i]->planestart[1] = ReadInt32(ihandle);
		mapheaderseg[i]->planestart[2] = ReadInt32(ihandle);

		mapheaderseg[i]->planelength[0] = ReadInt16(ihandle);
		mapheaderseg[i]->planelength[1] = ReadInt16(ihandle);
		mapheaderseg[i]->planelength[2] = ReadInt16(ihandle);
		mapheaderseg[i]->width = ReadInt16(ihandle);
		mapheaderseg[i]->height = ReadInt16(ihandle);
		ReadBytes(ihandle, (byte *)mapheaderseg[i]->name, 16);
		printf(" %dx%d at %x(%d)/%x(%d)\n", mapheaderseg[i]->width, mapheaderseg[i]->height, mapheaderseg[i]->planestart[0],
		         mapheaderseg[i]->planelength[0], mapheaderseg[i]->planestart[1], mapheaderseg[i]->planelength[1]);

        printf(" Cacheing map #%d\n", j);
		CA_CacheMap(i, ihandle);
	}

    WriteInt32(ohandle, 0x12345678); // skip first location to prevent 0 offset for map headers
	for (i = 0, k = 0; i < NUMMAPS; i++)
	{
		pos = mapstarts[i];
		if (pos == 0)
			continue;

		WriteInt32(ohandle, 4 + j*sizeof(maptype) + 64*64*2*k++); // mapheaderseg[i]->planestart[0]
		WriteInt32(ohandle, 4 + j*sizeof(maptype) + 64*64*2*k++); // mapheaderseg[i]->planestart[1]
		WriteInt32(ohandle, 0); // Err... NUMPLANES = 2, so mapheaderseg[i]->planestart[2] never used... toss it!

		WriteInt32(ohandle, 64*64*2); // mapheaderseg[i]->planelength[0]
		WriteInt32(ohandle, 64*64*2); // mapheaderseg[i]->planelength[1]
		WriteInt32(ohandle, 0); // Err... NUMPLANES = 2, so mapheaderseg[i]->planelength[2] never used... toss it!
		WriteInt32(ohandle, mapheaderseg[i]->width);
		WriteInt32(ohandle, mapheaderseg[i]->height);
		WriteBytes(ohandle, (byte *)mapheaderseg[i]->name, 16);
	}

	for (i = 0; i < NUMMAPS; i++)
	{
		pos = mapstarts[i];
		if (pos == 0)
			continue;

    	for (plane = 0; plane < MAPPLANES; plane++)
    	    for (j = 0; j < 64*64; j++)
    	        WriteInt16(ohandle, mapsegs[i][plane][j]);
    }

	CloseRead(ihandle);
	CloseWrite(ohandle);
}

static void process_vgahead(void)
{
    int ihandle, ohandle;
	char iname[80];
	int i;
	byte *grtemp;

	strcpy(iname, "data/original/vgahead.");
	strcat(iname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }

     /* load the data offsets from vgahead.ext */
	//MM_GetPtr((memptr)&grstarts, (NUMCHUNKS+1)*4);
	grstarts = malloc((NUMCHUNKS+1)*4);
	//MM_GetPtr((memptr)&grtemp, (NUMCHUNKS+1)*3);
	grtemp = malloc((NUMCHUNKS+1)*3);

	ReadBytes(ihandle, grtemp, (NUMCHUNKS+1)*3);

	for (i = 0; i < NUMCHUNKS+1; i++) {
		grstarts[i] = (grtemp[i*3+0]<<0)|(grtemp[i*3+1]<<8)|(grtemp[i*3+2]<<16);
    }

	//MM_FreePtr((memptr)&grtemp);
	free(grtemp);

    CloseRead(ihandle);
    CloseWrite(ohandle);
}

static void process_vgagraph(void)
{
    int hhandle, ihandle, ohandle;
	char hname[80];
	char iname[80];
	char oname[80];
	int i;
	long pos;
	byte *grtemp;

    // load the huffman dictionary
	strcpy(iname, "data/original/vgadict.");
	strcat(iname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }

	for (i = 0; i < 256; i++) {
		grhuffman[i].bit0 = ReadInt16(ihandle);
		grhuffman[i].bit1 = ReadInt16(ihandle);
	}

	CloseRead(ihandle);

	strcpy(hname, "romfiles/vgahead.");
	strcat(hname, EXTENSION);
	strcpy(iname, "data/original/vgagraph.");
	strcat(iname, EXTENSION);
	strcpy(oname, "romfiles/vgagraph.");
	strcat(oname, EXTENSION);

    hhandle = OpenWrite(hname);
	if (hhandle == -1) {
	    printf("Couldn't open %s to write\n", hname);
	    return;
    }

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    CloseWrite(hhandle);
	    return;
    }

    ohandle = OpenWrite(oname);
	if (ohandle == -1) {
	    printf("Couldn't open %s to write\n", oname);
	    CloseWrite(hhandle);
	    CloseRead(ihandle);
	    return;
    }

    grhandle = ihandle;

    /* load the pic headers into pictable */
	CA_CacheGrChunk(STRUCTPIC);

	grtemp = grsegs[STRUCTPIC];
	for (i = 0; i < NUMPICS; i++) {
		pictable[i].width = grtemp[i*4+0] | (grtemp[i*4+1] << 8);
		pictable[i].height = grtemp[i*4+2] | (grtemp[i*4+3] << 8);
	}

    /* cache all gr chunks */
	for (i = 0; i < NUMCHUNKS; i++)
    	CA_CacheGrChunk(i);

    /* write all uncompressed gr chunks */
	for (i = 0, pos = 0; i < NUMCHUNKS+1; i++) {
	    // write offset to vgahead
	    WriteInt32(hhandle, pos);
	    // write the data for each chunk to vgagraph
        WriteBytes(ohandle, grsegs[i], csize[i]);
        pos += csize[i];
    }

    CloseWrite(hhandle);
    CloseRead(ihandle);
    CloseWrite(ohandle);
}

static void process_vswap(void)
{
    // vswap has the offset and lengths for the chunks, then the chunks which hold
    // the ceiling, floor, and wall textures, followed by the sprite compiling commands,
    // followed by the sounds - we are ditching the lengths and decompiling the sprites
    int ihandle, ohandle;
	long pos;
	char iname[80];
	char oname[80];
	int i;

	strcpy(iname, "data/original/vswap.");
	strcat(iname, EXTENSION);
	strcpy(oname, "romfiles/vswap.");
	strcat(oname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }

    ohandle = OpenWrite(oname);
	if (ohandle == -1) {
	    printf("Couldn't open %s to write\n", oname);
	    CloseRead(ihandle);
	    return;
    }

	/* Read in header variables */
	ChunksInFile = ReadInt16(ihandle);
	PMSpriteStart = ReadInt16(ihandle);
	PMSoundStart = ReadInt16(ihandle);

    printf("ChunksInFile: %d, PMSpriteStart: %d, PMSoundStart: %d, SPR_TOTAL: %d\n", ChunksInFile, PMSpriteStart, PMSoundStart, SPR_TOTAL);

	/* Allocate and clear the page list */
	//MM_GetPtr((memptr)&PMPages, sizeof(PageListStruct) * ChunksInFile);
	//MM_SetLock((memptr)&PMPages, true);
	PMPages = malloc(sizeof(memptr) * ChunksInFile);
	PMOffsets = malloc(sizeof(int) * ChunksInFile);
	PMLengths = malloc(sizeof(int) * ChunksInFile);

	memset(PMPages, 0, sizeof(memptr) * ChunksInFile);

	/* Read in the chunk offsets */
	for (i = 0; i < ChunksInFile; i++) {
		PMOffsets[i] = ReadInt32(ihandle);
	}

	/* Read in the chunk lengths */
	for (i = 0; i < ChunksInFile; i++) {
		PMLengths[i] = (ReadInt16(ihandle) + 3) & ~3;
	}

	/* Read in the chunks */
	for (i = 0; i < ChunksInFile; i++) {
	    if (PMLengths[i] == 0)
	        continue;
	    printf("Reading chunk %d (%x:%d)...", i, PMOffsets[i], PMLengths[i]);
	    PMPages[i] = malloc(PMLengths[i]);
        ReadSeek(ihandle, PMOffsets[i], SEEK_SET);
		ReadBytes(ihandle, PMPages[i], PMLengths[i]);
		printf("done\n");
	}

    // decompile sprites
    memset(spritegfx, 0, SPR_TOTAL*4);
    for (i=0; i<(PMSoundStart-PMSpriteStart)+1; i++) {
        if (PMLengths[i+PMSpriteStart] == 0)
            continue;
        if (i>SPR_TOTAL)
            printf("Sprite total (%d) exceeded!\n", SPR_TOTAL);
        printf("Decompiling sprite %d\n", i);
        DeCompileSprite(i);
    }

    // now write vswap
    // write header
	WriteInt32(ohandle, ChunksInFile);
    WriteInt32(ohandle, PMSpriteStart);
	WriteInt32(ohandle, PMSoundStart);

    // write offsets
	for (i = 0, pos = 12+ChunksInFile*4; i<ChunksInFile; i++) {
	    if (i<PMSpriteStart) {
	        if (PMLengths[i] == 0)
	            WriteInt32(ohandle, 0);
	        else
	            WriteInt32(ohandle, pos);
	        pos += PMLengths[i];
        }
	    else if (i<PMSoundStart) {
	        if (spritegfx[i-PMSpriteStart] == 0)
	            WriteInt32(ohandle, 0);
            else {
	            WriteInt32(ohandle, pos);
	            pos += 64*64;
            }
        }
	    else {
	        if (PMLengths[i] == 0)
	            WriteInt32(ohandle, 0);
	        else
    	        WriteInt32(ohandle, pos);
	        pos += PMLengths[i];
        }
    }

    // write data
	for (i = 0; i < ChunksInFile; i++) {
	    if (i<PMSpriteStart) {
	        if (PMLengths[i] == 0)
	            continue;
            printf("Writing texture %d...", i);
	        WriteBytes(ohandle, PMPages[i], PMLengths[i]);
	        printf("done\n");
        }
	    else if (i<PMSoundStart) {
	        if (spritegfx[i-PMSpriteStart] == 0)
	            continue;
            printf("Writing sprite %d...", i-PMSpriteStart);
	        WriteBytes(ohandle, spritegfx[i-PMSpriteStart], 64*64);
	        printf("done\n");
        }
	    else {
	        if (PMLengths[i] == 0)
	            continue;
            printf("Writing sound %d...", i-PMSoundStart);
	        WriteBytes(ohandle, PMPages[i], PMLengths[i]);
	        printf("done\n");
        }
    }

    CloseRead(ihandle);
    CloseWrite(ohandle);
}
